; Source for Power.com written for NASM compiler
; Written by Donald J. Bindner
; April 1998

    org 100h
    jmp begin

no_apm db 'APM not available or error.',13,10,'$'
no_con db 'APM connection failed; could not request power-down.',13,10,'$'
failed db 'APM request for power-down failed.',13,10,'$'

begin:
    mov ax, 5300h		; APM Installation check
    xor bx,bx			; bios device select
    int 15h
    jc .L1			; if error
    cmp bx, 504Dh		; test for APM signature
    je .L2			; and print error if it doesn't exist

.L1:				; APM Not installed or error
    push word no_apm
    call print
    jmp .exit

.L2:
    mov ax, 5301h		; APM Create real mode connection
    xor bx, bx			; bios device select
    int 15h
    jnc .L4			; if no error

.L3:				; couldn't create connection
    push word no_con
    call print
    jmp .exit

.L4:				; request power-down
    mov ax, 5307h		; APM set power state
    mov bx, 01h			; all devices
    mov cx, 03h			; power off
    int 15h			; do it
    jnc .L6			; if no error

.L5:				; couldn't set power state
    push word failed
    call print

.L6: 
    mov ax, 5304h		; APM disconnect
    xor bx, bx			; bios device select
    int 15h			; do it

.exit:
    mov ax, 4C00h		; exit
    int 21h

print:
    push bp
    mov bp, sp
    push ax
    push dx
    mov dx, [bp+4]                  ; offset of message DS=CS assumed
    mov ah, 09h                     ; function to print message
    int 21h                         ; do it
    pop dx
    pop ax
    pop bp
    ret 2
